<?php
namespace Teknisa\CADFIS\Services; 

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;

class Ger05500ProdutosDesoneracaoImpostosService{
	protected $environment;
    protected $entityManager;
	protected $Ger05500ProdutosDesoneracaoImpostosFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Ger05500ProdutosDesoneracaoImpostosFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Ger05500ProdutosDesoneracaoImpostosFactory = $Ger05500ProdutosDesoneracaoImpostosFactory;
	} 


    public function deleteProdutosDesoneracao ($rows) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $nrorg = $this->environment->getNrOrgTrab();
            
            if(!isset($rows['NRORG']))
                $rows['NRORG'] = $nrorg;
                
            $existeFornecedor = $this->Ger05500ProdutosDesoneracaoImpostosFactory->verificaFornecedor($rows['CDPRODUTO'], $rows['NRORG']);
            
            if($existeFornecedor){
                foreach($existeFornecedor as $forn) {
                    $this->Ger05500ProdutosDesoneracaoImpostosFactory->deleteFornecedor($forn['CDPRODUTO'], $forn['NRORG']);
                }
            }  
            
            $existeCliente = $this->Ger05500ProdutosDesoneracaoImpostosFactory->verificaCliente($rows['CDPRODUTO'], $rows['NRORG']);
            
            if($existeCliente){
                foreach($existeCliente as $clien) {
                    $this->Ger05500ProdutosDesoneracaoImpostosFactory->deleteCliente($clien['CDPRODUTO'], $clien['NRORG']);
                }
            }
            
            $existeFilial = $this->Ger05500ProdutosDesoneracaoImpostosFactory->verificaFilial($rows['CDPRODUTO'], $rows['NRORG']);
            
            if($existeFilial){
                foreach($existeFilial as $fili) {
                    $this->Ger05500ProdutosDesoneracaoImpostosFactory->deleteFilial($fili['CDPRODUTO'], $fili['NRORG']);
                }
            }
            
            $connection->commit();
        }
        catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    /*public function deleteProdutoFornecedor($row, $nrorg){
        try {
            $produtosFornecedor = prodesoneraimfor::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?', array($nrorg, $row["CDPRODUTO"]));

            foreach($produtosFornecedor as $forn) {
                $forn->delete();
                Registry::getEntityManager()->flush();
            }
        }
        catch (\Exception $e) {
            throw $e;
        }
    }*/
}