<?php
namespace Contabilidade\Logic\ManutencaoLote;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Setforms2\Shared\Registry;
use Contabilidade\Entities\Capalote;
use \Geral\Util\DateUtil;

class ManutencaoLote
{
    public static function procedureReverter($empresa, $cdlote){
        try{
            $procedure = new Procedure('REVERTE_LOTE');
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $empresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDLOTE', Param::PARAM_INPUT, $cdlote, Param::PARAM_TYPE_STR));
            $procedure->call();
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public static function procedureLiberar($empresa, $cdlote, $nrlanc, $cdoperador){
        try{
            $procedure = new Procedure('LIBERA_LOTE');
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $empresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDLOTE', Param::PARAM_INPUT, $cdlote, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANC', Param::PARAM_INPUT, $nrlanc, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
            $procedure->call();
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public static function updateConfereLote($nrorg, $cdempresa, $cdlote, $credito, $debito, $qtde_erros){
        try {
            $capalote = Capalote::findOneByCdempresaAndNrorgAndCdlote($cdempresa, $nrorg, $cdlote);
            $capalote->setVrtotdbdigi($debito);
            $capalote->setVrtotcrdigi($credito);
            $capalote->setIdlote('C');
            $capalote->setQterrolote($qtde_erros);
            $capalote->persist();
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            Throw $e;
        }
    }
}